import sys, time

from threading import Thread

from Decoder import Decoder
#from Queue import PlayerEnd
#from Io.Files import ErrorLog

debug = True

class Player:

  # we get commands from The Q
  #q = PlayerEnd()

  decoder = Decoder()

  #errorLog = ErrorLog()

  msg = dict()

  commands = ( "play", "stop", "die" )

  #

  def mainloop(self):
    if debug: print time.time(), "mainloop: running..."
    while 1:
      if debug: print time.time(), "mainloop: waiting for next command..."
      self.getNextCommand() #blocking
      if debug: print time.time(), "mainloop: done with getNextCommand"
      self.handleCommand()
      if debug: print time.time(), "mainloop: done with handleCommand"

  #

  def getNextCommand(self):
    self.msg = self.q.next()
    if debug: print time.time(), "getNextCommand: got command:", self.msg


  def handleCommand(self):
    if debug: print time.time(), "handleCommand: running.."
    newThread = Thread(target=self._handleCommand)
    if debug: print time.time(), "handleCommand: created thread"
    newThread.start()
    if debug: print time.time(), "handleCommand: started thread, exiting"

  #

  def _handleCommand(self):
    if debug: print time.time(), "_handleCommand: running.."
    # we are now in our own thread
    cmd = self.msg["command"]

    if debug and cmd == "code":
      import code
      code.interact()
      return

    if cmd not in self.commands:
      if debug: print time.time(), "_handleCommand: cmd `%s' unknown, returning" % cmd
      self.errorLog.unknownCommand(cmd)
      return

    if cmd == self.commands[0]:
      if debug: print time.time(), "_handleCommand: cmd is [0], play"
      self.playSong()

    elif cmd == self.commands[1]:
      if debug: print time.time(), "_handleCommand: cmd is [1], stop"
      self.stop()

    elif cmd == self.commands[2]:
      if debug: print time.time(), "_handleCommand: cmd is [2], die"
      self.die()

    if debug: print time.time(), "_handleCommand: done"

  #

  def playSong(self):
    song = self.msg["data"]

    if debug: print time.time(), "playSong: playing %s" % song

    try:
      self.decoder.play(song)
    except IOError, err:
      if debug: print time.time(), "playSong:", err
      self.errorLog.writeError(err)
    if debug: print time.time(), "playSong: done playing song"

  def stop(self):
    if debug: print time.time(), "stop: running..."
    # can't stop a stopped decoder
    if self.decoder.stoppedBit.isSet():
      if debug: print time.time(), "stop: already stopped, returning"
      return

    # excuse me sir, please stop decoding that mp3.
    if debug: print time.time(), "stop: setting stopBit"
    self.decoder.stopBit.set()
    if debug: print time.time(), "stop: stopBit set"

    # who knows, something crazy could be happening on the machine, so
    # maybe this could take a few seconds in the absolute worst case
    # scenario.  if it takes more than 4, error and quit

    # have you stopped?
    if debug: print time.time(), "stop: waiting on stoppedBit, time: %s" % time.time()
    self.decoder.stoppedBit.wait(4)
    if debug: print time.time(), "stop: done waiting on stoppedBit, time: %s" % time.time()

    # if not, then something is wrong, log error and quit!
    if not self.decoder.stoppedBit.isSet():
      if debug: print time.time(), "stop: stoppedBit never got set, decoder hung, logging and exiting"
      self.errorLog.decoderHung()
      self.die()

    # else, it has stopped.  everything is good.

  def die(self, msg=None):
    if debug: print time.time(), "die: running.."
    self.errorLog.die(msg)
    if debug: print time.time(), "die: bye"
    sys.exit(0)




class myq:
  def next(self):
    text = raw_input()
    firstSpace = text.find(" ")

    if firstSpace != -1:
      cmd = text[:firstSpace].strip()
      data = text[firstSpace:].strip()
    else:
      cmd = text.strip()
      data = ""

    return { "command": cmd, "data": data }

class erlog:
  writeError=die=decoderHung=unknownCommand=fileNotFound=lambda *a,**b:None

if __name__ == "__main__":
  player = Player()
  player.q = myq()
  player.errorLog = erlog()
  player.mainloop()

